import 'dart:convert';
import 'package:aitrainer_app/model/customer.dart';
import 'package:aitrainer_app/model/user.dart';
import 'package:aitrainer_app/service/api.dart';
import 'package:aitrainer_app/model/auth.dart';

class CustomerApi {
  final APIClient _client=new APIClient();

  Future<List<Customer>> getRealCustomers(String param) async {
    final body = await _client.get("customers/", param);
    final Iterable json = jsonDecode(body);
    final List<Customer> customers = json.map( (customer) => Customer.fromJson(customer) ).toList();

    return customers;
  }

  Future<void> saveCustomer(Customer customer) async {
    String body = JsonEncoder().convert(customer.toJson());
    print(" ===== saving exerciseType id: " + customer.customerId.toString() + ":" + body );
    await _client.post(
        "customers/"+customer.customerId.toString(),
        body);
  }

  Future<void> addCustomer(Customer customer) async {
    String body = JsonEncoder().convert(customer.toJson());
    print(" ===== add new customer: " + body );
    await _client.post(
        "customers",
        body);
  }

  Future<void> addUser(User user) async {
    String body = JsonEncoder().convert(user.toJson());
    print(" ===== register new user: " + body );
    final String responseBody = await _client.post(
        "registration",
        body);
    Auth auth = Auth();
    Customer customer = Customer.fromJson(jsonDecode(responseBody));
    auth.afterRegistration(customer);

  }

  Future<void> getUser(User user) async {
    String body = JsonEncoder().convert(user.toJson());
    print(" ===== login the user: " + body );
    final String responseBody = await _client.post(
        "login",
        body);
    Auth auth = Auth();
    Customer customer = Customer.fromJson(jsonDecode(responseBody));
    auth.afterRegistration(customer);
  }

  Future<void> getCustomer(int customerId) async {
    String body = "";
    print(" ===== get the customer by id: " + customerId.toString() );
    final String responseBody = await _client.get(
        "customers/"+customerId.toString(),
        body);
    Auth auth = Auth();
    Customer customer = Customer.fromJson(jsonDecode(responseBody));
    auth.afterRegistration(customer);
  }
}