import 'package:aitrainer_app/model/user.dart';
import 'package:aitrainer_app/service/customer_service.dart';
import 'package:aitrainer_app/viewmodel/user_view_model.dart';
import 'package:flutter/cupertino.dart';

class UserChangingViewModel extends ChangeNotifier {
  UserViewModel userViewModel = UserViewModel();

  UserChangingViewModel(userViewModel) {
    this.userViewModel = userViewModel;
  }

  Future<void> addUser() async {
    final User modelUser = userViewModel.getUser();
    await CustomerApi().addUser(modelUser);
  }

  Future<void> getUser() async {
    final User modelUser = userViewModel.getUser();
    await CustomerApi().getUser(modelUser);
  }
}